 /*------------------------------------------------------------
  *  Copyright 2002 By Kara K.W. Poon and Steve Wilton
  *
  * Permission to use, copy, and modify this software and its documentation
is
  * hereby granted only under the following terms and conditions.  Both the
  * above copyright notice and this permission notice must appear in all
copies
  * of the software, derivative works or modified versions, and any portions
  * thereof, and both notices must appear in supporting documentation.
  * Permission is granted ONLY for non-commercial use.  For
  * commercial use, please contact the authors.
  *
  * This software may be distributed (but not offered for sale or
transferred
  * for compensation) to third parties, provided such third parties agree to
  * abide by the terms and conditions of this notice.
  *
  * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHORS, AS
  * WELL AS THE UNIVERSITY OF BRITISH COLUMBIA AND THE
  * UNIVERSITY OF TORONTO DISCLAIM ALL WARRANTIES WITH
  * REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES
  * OF MERCHANTABILITY AND FITNESS.   IN NO EVENT SHALL THE
  * AUTHORS OR THE UNIVERSITY OF BRITISH COLUMBIA OR THE
  * UNIVERSITY OF TORONTO BE LIABLE FOR ANY SPECIAL, DIRECT,
  * INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
  * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR
  * PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE
  * OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
  * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
  *------------------------------------------------------------*/
/*
  VPR was first written by Vaugh Betz at the University of 
  Toronto. Descriptions on different versions of VPR is available
  in the descript.txt file.

  The power model is an extension of the original VPR. This 
  feature is added by Kara Poon at the University of British 
  Columbia as a master thesis project supervised by Dr. Steve
  Wilton.

 */


/* Netlist to be placed stuff. */
extern int num_nets, num_blocks;     
extern int num_p_inputs, num_p_outputs, num_clbs, num_globals;
extern struct s_net *net;
extern struct s_block *block;
extern boolean *is_global;

/*--- c.a:  hwrp ---*/
boolean disable_hwrp;
boolean enable_random_seed;

/* Physical FPGA architecture stuff */
extern int nx, ny, io_rat, pins_per_clb, num_global_clock;
extern int **pinloc;
extern int *clb_pin_class;
extern boolean *is_global_clb_pin;
extern struct s_class *class_inf;
extern int num_class;
extern struct clock_details *clock_inf;

/* chan_width_x is the x-directed channel; i.e. between rows */
extern int *chan_width_x, *chan_width_y; /* numerical form */
extern struct s_clb **clb;

/* [0..num_nets-1] of linked list start pointers.  Defines the routing.  */
extern struct s_trace **trace_head, **trace_tail;   

/* Structures to define the routing architecture of the FPGA.           */
extern int num_rr_nodes;
extern t_rr_node *rr_node;                   /* [0..num_rr_nodes-1]          */
extern int num_rr_indexed_data;
extern t_rr_indexed_data *rr_indexed_data;   /* [0 .. num_rr_indexed_data-1] */
extern int **net_rr_terminals;             /* [0..num_nets-1][0..num_pins-1] */
extern struct s_switch_inf *switch_inf; /* [0..det_routing_arch.num_switch-1] */
extern int **rr_clb_source;              /* [0..num_blocks-1][0..num_class-1] */
extern int operation_temperature;
extern int num_temperature_records;      /*Number of different temperatures 
														 in .arch file */
extern struct temperature_record *NFS_records; /* [0..num_temperature_records]*/
extern struct transistor_record NMOS_tx_record;
extern struct transistor_record PMOS_tx_record;
extern struct poly_record poly_inf;
extern float swing_voltage;
extern float supply_voltage;
extern float Vgs_for_leakage;
extern float SRAM_leakage;
extern float short_circuit_power_percentage;

